Index: kern/lwkt_thread.c
===================================================================
RCS file: /cvs/src/sys/kern/lwkt_thread.c,v
retrieving revision 1.55
diff -u -r1.55 lwkt_thread.c
--- kern/lwkt_thread.c	17 Feb 2004 19:38:49 -0000	1.55
+++ kern/lwkt_thread.c	23 Feb 2004 05:53:14 -0000
@@ -174,9 +174,12 @@
  * NOTE!  called from low level boot code, we cannot do anything fancy!
  */
 void
-lwkt_init_wait(lwkt_wait_t w)
+lwkt_wait_init(lwkt_wait_t w)
 {
+    lwkt_token_init(&w->wa_token);
     TAILQ_INIT(&w->wa_waitq);
+    w->wa_gen = 0;
+    w->wa_count = 0;
 }
 
 /*
@@ -246,6 +249,8 @@
  * NOTE! we have to be careful in regards to creating threads for other cpus
  * if SMP has not yet been activated.
  */
+#ifdef SMP
+
 static void
 lwkt_init_thread_remote(void *arg)
 {
@@ -254,6 +259,8 @@
     TAILQ_INSERT_TAIL(&td->td_gd->gd_tdallq, td, td_allq);
 }
 
+#endif
+
 void
 lwkt_init_thread(thread_t td, void *stack, int flags, struct globaldata *gd)
 {
@@ -379,7 +386,7 @@
 void
 lwkt_switch(void)
 {
-    struct globaldata *gd;
+    globaldata_t gd;
     thread_t td = curthread;
     thread_t ntd;
 #ifdef SMP
@@ -462,9 +469,24 @@
 	 *
 	 * We have to adjust the MP lock for the target thread.  If we 
 	 * need the MP lock and cannot obtain it we try to locate a
-	 * thread that does not need the MP lock.
+	 * thread that does not need the MP lock.  If we cannot, we spin
+	 * instead of HLT.
+	 *
+	 * A similar issue exists for the tokens held by the target thread.
+	 * If we cannot obtain ownership of the tokens we cannot immediately
+	 * schedule the thread.
+	 */
+
+	/*
+	 * We are switching threads.  If there are any pending requests for
+	 * tokens we can satisfy all of them here.
 	 */
 	gd = mycpu;
+#ifdef SMP
+	if (gd->gd_tokreqbase)
+		lwkt_drain_token_requests();
+#endif
+
 again:
 	if (gd->gd_runqmask) {
 	    int nq = bsrl(gd->gd_runqmask);
@@ -473,17 +495,24 @@
 		goto again;
 	    }
 #ifdef SMP
-	    if (ntd->td_mpcount && mpheld == 0 && !cpu_try_mplock()) {
-		/*
-		 * Target needs MP lock and we couldn't get it, try
-		 * to locate a thread which does not need the MP lock
-		 * to run.  If we cannot locate a thread spin in idle.
-		 */
+	    /*
+	     * If the target needs the MP lock and we couldn't get it,
+	     * or if the target is holding tokens and we could not 
+	     * gain ownership of the tokens, continue looking for a
+	     * thread to schedule and spin instead of HLT if we can't.
+	     */
+	    if ((ntd->td_mpcount && mpheld == 0 && !cpu_try_mplock()) ||
+		(ntd->td_toks && lwkt_chktokens(ntd) == 0)
+	    ) {
 		u_int32_t rqmask = gd->gd_runqmask;
 		while (rqmask) {
 		    TAILQ_FOREACH(ntd, &gd->gd_tdrunq[nq], td_threadq) {
-			if (ntd->td_mpcount == 0)
-			    break;
+			if (ntd->td_mpcount && !mpheld && !cpu_try_mplock())
+			    continue;
+			mpheld = MP_LOCK_HELD();
+			if (ntd->td_toks && !lwkt_chktokens(ntd))
+			    continue;
+			break;
 		    }
 		    if (ntd)
 			break;
@@ -603,6 +632,10 @@
      *
      * YYY The target thread must be in a critical section (else it must
      * inherit our critical section?  I dunno yet).
+     *
+     * Any tokens held by the target may not be held by thread(s) being
+     * preempted.  We take the easy way out and do not preempt if
+     * the target is holding tokens.
      */
     KASSERT(ntd->td_pri >= TDPRI_CRIT, ("BADCRIT0 %d", ntd->td_pri));
 
@@ -621,6 +654,17 @@
 	return;
     }
 #endif
+    /*
+     * Take the easy way out and do not preempt if the target is holding
+     * one or more tokens.  We could test whether the thread(s) being
+     * preempted interlock against the target thread's tokens and whether
+     * we can get all the target thread's tokens, but this situation 
+     * should not occur very often so its easier to simply not preempt.
+     */
+    if (ntd->td_toks != NULL) {
+	++preempt_miss;
+	return;
+    }
     if (td == ntd || ((td->td_flags | ntd->td_flags) & TDF_PREEMPT_LOCK)) {
 	++preempt_weird;
 	return;
@@ -754,14 +798,15 @@
 {
     thread_t td = curthread;
 
-    crit_enter();
+    crit_enter_quick(td);
     KASSERT(td->td_wait == NULL, ("lwkt_schedule_self(): td_wait not NULL!"));
+    KASSERT(td != &td->td_gd->gd_idlethread, ("lwkt_schedule_self(): scheduling gd_idlethread is illegal!"));
     _lwkt_enqueue(td);
 #ifdef _KERNEL
     if (td->td_proc && td->td_proc->p_stat == SSLEEP)
 	panic("SCHED SELF PANIC");
 #endif
-    crit_exit();
+    crit_exit_quick(td);
 }
 
 /*
@@ -776,6 +821,7 @@
 lwkt_schedule(thread_t td)
 {
 #ifdef	INVARIANTS
+    KASSERT(td != &td->td_gd->gd_idlethread, ("lwkt_schedule(): scheduling gd_idlethread is illegal!"));
     if ((td->td_flags & TDF_PREEMPT_LOCK) == 0 && td->td_proc 
 	&& td->td_proc->p_stat == SSLEEP
     ) {
@@ -807,7 +853,9 @@
 	 * (remember, wait structures use stable storage)
 	 */
 	if ((w = td->td_wait) != NULL) {
-	    if (lwkt_trytoken(&w->wa_token)) {
+	    lwkt_tokref wref;
+
+	    if (lwkt_trytoken(&wref, &w->wa_token)) {
 		TAILQ_REMOVE(&w->wa_waitq, td, td_threadq);
 		--w->wa_count;
 		td->td_wait = NULL;
@@ -828,7 +876,7 @@
 		else if (_lwkt_wantresched(td, curthread))
 		    need_resched();
 #endif
-		lwkt_reltoken(&w->wa_token);
+		lwkt_reltoken(&wref);
 	    } else {
 		lwkt_send_ipiq(w->wa_token.t_cpu, (ipifunc_t)lwkt_schedule, td);
 	    }
@@ -980,43 +1028,36 @@
     return(td->td_proc);
 }
 
-#if 0
-
 /*
- * This function deschedules the current thread and blocks on the specified
- * wait queue.  We obtain ownership of the wait queue in order to block
- * on it.  A generation number is used to interlock the wait queue in case
- * it gets signalled while we are blocked waiting on the token.
- *
- * Note: alternatively we could dequeue our thread and then message the
- * target cpu owning the wait queue.  YYY implement as sysctl.
- *
- * Note: wait queue signals normally ping-pong the cpu as an optimization.
+ * Block on the specified wait queue until signaled.  A generation number
+ * must be supplied to interlock the wait queue.  The function will
+ * return immediately if the generation number does not match the wait
+ * structure's generation number.
  */
-
 void
 lwkt_block(lwkt_wait_t w, const char *wmesg, int *gen)
 {
     thread_t td = curthread;
+    lwkt_tokref ilock;
 
-    lwkt_gettoken(&w->wa_token);
+    lwkt_gettoken(&ilock, &w->wa_token);
+    crit_enter();
     if (w->wa_gen == *gen) {
 	_lwkt_dequeue(td);
 	TAILQ_INSERT_TAIL(&w->wa_waitq, td, td_threadq);
 	++w->wa_count;
 	td->td_wait = w;
 	td->td_wmesg = wmesg;
-again:
+    again:
 	lwkt_switch();
-	lwkt_regettoken(&w->wa_token);
 	if (td->td_wmesg != NULL) {
 	    _lwkt_dequeue(td);
 	    goto again;
 	}
     }
-    /* token might be lost, doesn't matter for gen update */
+    crit_exit();
     *gen = w->wa_gen;
-    lwkt_reltoken(&w->wa_token);
+    lwkt_reltoken(&ilock);
 }
 
 /*
@@ -1031,10 +1072,11 @@
 lwkt_signal(lwkt_wait_t w, int count)
 {
     thread_t td;
-    int count;
+    lwkt_tokref ilock;
 
-    lwkt_gettoken(&w->wa_token);
+    lwkt_gettoken(&ilock, &w->wa_token);
     ++w->wa_gen;
+    crit_enter();
     if (count < 0)
 	count = w->wa_count;
     while ((td = TAILQ_FIRST(&w->wa_waitq)) != NULL && count) {
@@ -1048,12 +1090,10 @@
 	} else {
 	    lwkt_send_ipiq(td->td_gd, (ipifunc_t)lwkt_schedule, td);
 	}
-	lwkt_regettoken(&w->wa_token);
     }
-    lwkt_reltoken(&w->wa_token);
+    crit_exit();
+    lwkt_reltoken(&ilock);
 }
-
-#endif
 
 /*
  * Create a kernel process/thread/whatever.  It shares it's address space
Index: kern/lwkt_token.c
===================================================================
RCS file: /cvs/src/sys/kern/lwkt_token.c,v
retrieving revision 1.4
diff -u -r1.4 lwkt_token.c
--- kern/lwkt_token.c	18 Feb 2004 16:31:37 -0000	1.4
+++ kern/lwkt_token.c	23 Feb 2004 18:51:04 -0000
@@ -75,10 +75,20 @@
 
 #endif
 
+#define	MAKE_TOKENS_SPIN
+/* #define MAKE_TOKENS_YIELD */
+
+#ifndef LWKT_NUM_POOL_TOKENS
+#define LWKT_NUM_POOL_TOKENS	1024	/* power of 2 */
+#endif
+#define LWKT_MASK_POOL_TOKENS	(LWKT_NUM_POOL_TOKENS - 1)
+
 #ifdef INVARIANTS
 static int token_debug = 0;
 #endif
 
+static lwkt_token	pool_tokens[LWKT_NUM_POOL_TOKENS];
+
 #ifdef _KERNEL
 
 #ifdef INVARIANTS
@@ -87,214 +97,428 @@
 
 #endif
 
-typedef struct lwkt_gettoken_req {
-    lwkt_token_t tok;
-    globaldata_t cpu;
-} lwkt_gettoken_req;
+#ifdef SMP
 
 /*
- * Acquire ownership of a token
- *
- * Acquire ownership of a token.  The token may have spl and/or critical
- * section side effects, depending on its purpose.  These side effects
- * guarentee that you will maintain ownership of the token as long as you
- * do not block.  If you block you may lose access to the token (but you
- * must still release it even if you lose your access to it).
- *
- * YYY for now we use a critical section to prevent IPIs from taking away
- * a token, but do we really only need to disable IPIs ?
- *
- * YYY certain tokens could be made to act like mutexes when performance
- * would be better (e.g. t_cpu == NULL).  This is not yet implemented.
- *
- * YYY the tokens replace 4.x's simplelocks for the most part, but this
- * means that 4.x does not expect a switch so for now we cannot switch
- * when waiting for an IPI to be returned.  
+ * Determine if we own all the tokens in the token reference list.
+ * Return 1 on success, 0 on failure. 
  *
- * YYY If the token is owned by another cpu we may have to send an IPI to
- * it and then block.   The IPI causes the token to be given away to the
- * requesting cpu, unless it has already changed hands.  Since only the
- * current cpu can give away a token it owns we do not need a memory barrier.
- * This needs serious optimization.
+ * As a side effect, queue requests for tokens we want which are owned
+ * by other cpus.  The magic number is used to communicate when the 
+ * target cpu has processed the request.  Note, however, that the
+ * target cpu may not be able to assign the token to us which is why
+ * the scheduler must spin.
  */
-
-#ifdef SMP
-
-static
-void
-lwkt_gettoken_remote(void *arg)
+int
+lwkt_chktokens(thread_t td)
 {
-    lwkt_gettoken_req *req = arg;
-    if (req->tok->t_cpu == mycpu) {
-#ifdef INVARIANTS
-	if (token_debug)
-	    printf("GT(%d,%d) ", req->tok->t_cpu->gd_cpuid, req->cpu->gd_cpuid);
-#endif
-	req->tok->t_cpu = req->cpu;
-	req->tok->t_reqcpu = req->cpu;	/* YYY leave owned by target cpu */
-	/* else set reqcpu to point to current cpu for release */
+    globaldata_t gd = td->td_gd;	/* mycpu */
+    lwkt_tokref_t refs;
+    globaldata_t dgd;
+    lwkt_token_t tok;
+    int r = 1;
+
+    for (refs = td->td_toks; refs; refs = refs->tr_next) {
+	tok = refs->tr_tok;
+	if ((dgd = tok->t_cpu) != gd) {
+	    cpu_mb1();
+	    r = 0;
+
+	    /*
+	     * Queue a request to the target cpu, exit the loop early if
+	     * we are unable to queue the IPI message.  The magic number
+	     * flags whether we have a pending ipi request queued or not.
+	     */
+	    if (refs->tr_magic == LWKT_TOKREF_MAGIC1) {
+		refs->tr_magic = LWKT_TOKREF_MAGIC2;	/* MP synched slowreq*/
+		refs->tr_reqgd = gd;
+		tok->t_reqcpu = gd;	/* MP unsynchronized 'fast' req */
+		if (lwkt_send_ipiq_passive(dgd, lwkt_reqtoken_remote, refs)) {
+		    /* failed */
+		    refs->tr_magic = LWKT_TOKREF_MAGIC1;
+		    break;
+		}
+	    }
+	}
     }
+    return(r);
 }
 
 #endif
 
+/*
+ * Check if we already own the token.  Return 1 on success, 0 on failure.
+ */
 int
-lwkt_gettoken(lwkt_token_t tok)
+lwkt_havetoken(lwkt_token_t tok)
 {
-    /*
-     * Prevent preemption so the token can't be taken away from us once
-     * we gain ownership of it.  Use a synchronous request which might
-     * block.  The request will be forwarded as necessary playing catchup
-     * to the token.
-     */
-
-    crit_enter();
-#ifdef INVARIANTS
-    if (curthread->td_pri > 1800) {
-	printf("lwkt_gettoken: %p called from %p: crit sect nesting warning\n",
-	    tok, ((int **)&tok)[-1]);
+    globaldata_t gd = mycpu;
+    thread_t td = gd->gd_curthread;
+    lwkt_tokref_t ref;
+
+    for (ref = td->td_toks; ref; ref = ref->tr_next) {
+        if (ref->tr_tok == tok)
+            return(1);
     }
-    if (curthread->td_pri > 2000) {
-	curthread->td_pri = 1000;
-	panic("too HIGH!");
+    return(0);
+}
+
+int
+lwkt_havetokref(lwkt_tokref_t xref)
+{
+    globaldata_t gd = mycpu;
+    thread_t td = gd->gd_curthread;
+    lwkt_tokref_t ref;
+
+    for (ref = td->td_toks; ref; ref = ref->tr_next) {
+        if (ref == xref)
+            return(1);
     }
-#endif
+    return(0);
+}
+
 #ifdef SMP
-    while (tok->t_cpu != mycpu) {
-	struct lwkt_gettoken_req req;
-	int seq;
-	globaldata_t dcpu;
 
-	req.cpu = mycpu;
-	req.tok = tok;
-	dcpu = tok->t_cpu;
-#ifdef INVARIANTS
-	if (token_debug)
-	    printf("REQT%d ", dcpu->gd_cpuid);
-#endif
-	seq = lwkt_send_ipiq(dcpu, lwkt_gettoken_remote, &req);
-	lwkt_wait_ipiq(dcpu, seq);
-#ifdef INVARIANTS
-	if (token_debug)
-	    printf("REQR%d ", tok->t_cpu->gd_cpuid);
-#endif
+/*
+ * Returns 1 if it is ok to give a token away, 0 if it is not.
+ */
+static int
+lwkt_oktogiveaway_token(lwkt_token_t tok)
+{
+    globaldata_t gd = mycpu;
+    lwkt_tokref_t ref;
+    thread_t td;
+
+    for (td = gd->gd_curthread; td; td = td->td_preempted) {
+	for (ref = td->td_toks; ref; ref = ref->tr_next) {
+	    if (ref->tr_tok == tok)
+		return(0);
+	}
     }
+    return(1);
+}
+
 #endif
+
+/*
+ * Acquire a serializing token
+ */
+
+static __inline
+void
+_lwkt_gettokref(lwkt_tokref_t ref)
+{
+    lwkt_token_t tok;
+    globaldata_t gd;
+    thread_t td;
+
+    gd = mycpu;			/* our cpu */
+    KKASSERT(ref->tr_magic == LWKT_TOKREF_MAGIC1);
+    td = gd->gd_curthread;	/* our thread */
+
+    /*
+     * Link the request into our thread's list.  This interlocks against
+     * remote requests from other cpus and prevents the token from being
+     * given away if our cpu already owns it.  This also allows us to
+     * avoid using a critical section.
+     */
+    ref->tr_next = td->td_toks;
+    cpu_mb1();		/* order memory / we can be interrupted */
+    td->td_toks = ref;
+
     /*
-     * leave us in a critical section on return.  This will be undone
-     * by lwkt_reltoken().  Bump the generation number.
+     * If our cpu does not own the token then let the scheduler deal with
+     * it.  We are guarenteed to own the tokens on our thread's token
+     * list when we are switched back in.
+     *
+     * Otherwise make sure the token is not held by a thread we are
+     * preempting.  If it is, let the scheduler deal with it.
      */
-    return(++tok->t_gen);
+    tok = ref->tr_tok;
+#ifdef SMP
+    if (tok->t_cpu != gd) {
+	/*
+	 * Temporarily operate on tokens synchronously.  We have to fix
+	 * a number of interlocks and especially the softupdates code to
+	 * be able to properly yield.  ZZZ
+	 */
+#if defined(MAKE_TOKENS_SPIN)
+	int x = 40000000;
+	crit_enter();
+	while (lwkt_chktokens(td) == 0) {
+	    lwkt_process_ipiq();
+	    lwkt_drain_token_requests();
+	    if (--x == 0) {
+		x = 40000000;
+		printf("CHKTOKEN loop %d\n", gd->gd_cpuid);
+		Debugger("x");
+	    }
+	    splz();
+	}
+	crit_exit();
+#elif defined(MAKE_TOKENS_YIELD)
+	lwkt_yield();
+#else
+#error MAKE_TOKENS_XXX ?
+#endif
+	KKASSERT(tok->t_cpu == gd);
+    } else /* NOTE CONDITIONAL */
+#endif
+    if (td->td_preempted) {
+	while ((td = td->td_preempted) != NULL) {
+	    lwkt_tokref_t scan;
+	    for (scan = td->td_toks; scan; scan = scan->tr_next) {
+		if (scan->tr_tok == tok) {
+		    lwkt_yield();
+		    KKASSERT(tok->t_cpu == gd);
+		    goto breakout;
+		}
+	    }
+	}
+breakout:
+    }
+    /* 'td' variable no longer valid due to preempt loop above */
 }
 
+
 /*
- * Attempt to acquire ownership of a token.  Returns 1 on success, 0 on
- * failure.
+ * Attempt to acquire a serializing token
  */
+static __inline
 int
-lwkt_trytoken(lwkt_token_t tok)
+_lwkt_trytokref(lwkt_tokref_t ref)
 {
-    crit_enter();
+    lwkt_token_t tok;
+    globaldata_t gd;
+    thread_t td;
+
+    gd = mycpu;			/* our cpu */
+    KKASSERT(ref->tr_magic == LWKT_TOKREF_MAGIC1);
+    td = gd->gd_curthread;	/* our thread */
+
+    /*
+     * Link the request into our thread's list.  This interlocks against
+     * remote requests from other cpus and prevents the token from being
+     * given away if our cpu already owns it.  This also allows us to
+     * avoid using a critical section.
+     */
+    ref->tr_next = td->td_toks;
+    cpu_mb1();		/* order memory / we can be interrupted */
+    td->td_toks = ref;
+
+    /*
+     * If our cpu does not own the token then stop now.
+     *
+     * Otherwise make sure the token is not held by a thread we are
+     * preempting.  If it is, stop.
+     */
+    tok = ref->tr_tok;
 #ifdef SMP
-    if (tok->t_cpu != mycpu) {
-	crit_exit();
+    if (tok->t_cpu != gd) {
+	td->td_toks = ref->tr_next;	/* remove ref */
 	return(0);
-    } 
+    } else /* NOTE CONDITIONAL */
 #endif
-    /* leave us in the critical section */
-    ++tok->t_gen;
+    if (td->td_preempted) {
+	while ((td = td->td_preempted) != NULL) {
+	    lwkt_tokref_t scan;
+	    for (scan = td->td_toks; scan; scan = scan->tr_next) {
+		if (scan->tr_tok == tok) {
+		    td = gd->gd_curthread;	/* our thread */
+		    td->td_toks = ref->tr_next;	/* remove ref */
+		    return(0);
+		}
+	    }
+	}
+    }
+    /* 'td' variable no longer valid */
     return(1);
 }
 
-/*
- * Release your ownership of a token.  Releases must occur in reverse
- * order to aquisitions, eventually so priorities can be unwound properly
- * like SPLs.  At the moment the actual implemention doesn't care.
- *
- * We can safely hand a token that we own to another cpu without notifying
- * it, but once we do we can't get it back without requesting it (unless
- * the other cpu hands it back to us before we check).
- *
- * We might have lost the token, so check that.
- *
- * Return the token's generation number.  The number is useful to callers
- * who may want to know if the token was stolen during potential blockages.
- */
-int
-lwkt_reltoken(lwkt_token_t tok)
+void
+lwkt_gettoken(lwkt_tokref_t ref, lwkt_token_t tok)
 {
-    int gen;
+    lwkt_tokref_init(ref, tok);
+    _lwkt_gettokref(ref);
+}
 
-    if (tok->t_cpu == mycpu) {
-	tok->t_cpu = tok->t_reqcpu;
-    }
-    gen = tok->t_gen;
-    crit_exit();
-    return(gen);
+void
+lwkt_gettokref(lwkt_tokref_t ref)
+{
+    _lwkt_gettokref(ref);
 }
 
-/*
- * Reacquire a token that might have been lost.  0 is returned if the 
- * generation has not changed (nobody stole the token from us), -1 is 
- * returned otherwise.  The token is reacquired regardless but the
- * generation number is not bumped further if we already own the token.
- *
- * For efficiency we inline the best-case situation for lwkt_regettoken()
- * (i.e .we still own the token).
- */
 int
-lwkt_gentoken(lwkt_token_t tok, int *gen)
+lwkt_trytoken(lwkt_tokref_t ref, lwkt_token_t tok)
 {
-    if (tok->t_cpu == mycpu && tok->t_gen == *gen)
-	return(0);
-    *gen = lwkt_regettoken(tok);
-    return(-1);
+    lwkt_tokref_init(ref, tok);
+    return(_lwkt_trytokref(ref));
+}
+
+int
+lwkt_trytokref(lwkt_tokref_t ref)
+{
+    return(_lwkt_trytokref(ref));
 }
 
 /*
- * Re-acquire a token that might have been lost.   The generation number
- * is bumped and returned regardless of whether the token had been lost
- * or not (because we only have cpu granularity we have to bump the token
- * either way).
+ * Release a serializing token
  */
-int
-lwkt_regettoken(lwkt_token_t tok)
+void
+lwkt_reltoken(lwkt_tokref *_ref)
 {
-    /* assert we are in a critical section */
-    if (tok->t_cpu != mycpu) {
-#ifdef SMP
-	while (tok->t_cpu != mycpu) {
-	    struct lwkt_gettoken_req req;
-	    int seq;
-	    globaldata_t dcpu;
+    lwkt_tokref *ref;
+    lwkt_tokref **pref;
+    lwkt_token_t tok;
+    globaldata_t gd;
+    thread_t td;
 
-	    req.cpu = mycpu;
-	    req.tok = tok;
-	    dcpu = tok->t_cpu;
+    /*
+     * Guard check and stack check (if in the same stack page).  We must
+     * also wait for any action pending on remote cpus which we do by
+     * checking the magic number and yielding in a loop.
+     */
+    ref = _ref;
 #ifdef INVARIANTS
-	    if (token_debug)
-		printf("REQT%d ", dcpu->gd_cpuid);
+    if ((((intptr_t)ref ^ (intptr_t)&_ref) && ~(intptr_t)PAGE_MASK) == 0)
+	KKASSERT((char *)ref > (char *)&_ref);
+    KKASSERT(ref->tr_magic == LWKT_TOKREF_MAGIC1 || 
+	     ref->tr_magic == LWKT_TOKREF_MAGIC2);
 #endif
-	    seq = lwkt_send_ipiq(dcpu, lwkt_gettoken_remote, &req);
-	    lwkt_wait_ipiq(dcpu, seq);
-#ifdef INVARIANTS
-	    if (token_debug)
-		printf("REQR%d ", tok->t_cpu->gd_cpuid);
+    /*
+     * Locate and unlink the token.  Interlock with the token's cpureq
+     * to give the token away before we release it from our thread list,
+     * which allows us to avoid using a critical section.
+     */
+    gd = mycpu;
+    td = gd->gd_curthread;
+    for (pref = &td->td_toks; (ref = *pref) != _ref; pref = &ref->tr_next) {
+	KKASSERT(ref != NULL);
+    }
+    tok = ref->tr_tok;
+    KKASSERT(tok->t_cpu == gd);
+    tok->t_cpu = tok->t_reqcpu;	/* we do not own 'tok' after this */
+    *pref = ref->tr_next;	/* note: also removes giveaway interlock */
+
+    /*
+     * If we had gotten the token opportunistically and it still happens to
+     * be queued to a target cpu, we have to wait for the target cpu
+     * to finish processing it.  This does not happen very often and does
+     * not need to be optimal.
+     */
+    while (ref->tr_magic == LWKT_TOKREF_MAGIC2) {
+#if defined(MAKE_TOKENS_SPIN)
+	crit_enter();
+#ifdef SMP
+	lwkt_process_ipiq();
 #endif
-	}
+	splz();
+	crit_exit();
+#elif defined(MAKE_TOKENS_YIELD)
+	lwkt_yield();
+#else
+#error MAKE_TOKENS_XXX ?
 #endif
     }
-    ++tok->t_gen;
-    return(tok->t_gen);
 }
 
+/*
+ * Pool tokens are used to provide a type-stable serializing token
+ * pointer that does not race against disappearing data structures.
+ *
+ * This routine is called in early boot just after we setup the BSP's
+ * globaldata structure.
+ */
 void
-lwkt_inittoken(lwkt_token_t tok)
+lwkt_token_pool_init(void)
 {
+    int i;
+
+    for (i = 0; i < LWKT_NUM_POOL_TOKENS; ++i)
+	lwkt_token_init(&pool_tokens[i]);
+}
+
+lwkt_token_t
+lwkt_token_pool_get(void *ptraddr)
+{
+    int i;
+
+    i = ((int)(intptr_t)ptraddr >> 2) ^ ((int)(intptr_t)ptraddr >> 12);
+    return(&pool_tokens[i & LWKT_MASK_POOL_TOKENS]);
+}
+
+#ifdef SMP
+
+/*
+ * This is the receiving side of a remote IPI requesting a token.  If we
+ * cannot immediately hand the token off to another cpu we queue it.
+ *
+ * NOTE!  we 'own' the ref structure, but we only 'own' the token if
+ * t_cpu == mycpu.
+ */
+void
+lwkt_reqtoken_remote(void *data)
+{
+    lwkt_tokref_t ref = data;
+    globaldata_t gd = mycpu;
+    lwkt_token_t tok = ref->tr_tok;
+
     /*
-     * Zero structure and set cpu owner and reqcpu to cpu 0.
+     * We do not have to queue the token if we can give it away
+     * immediately.  Otherwise we queue it to our globaldata structure.
      */
+    KKASSERT(ref->tr_magic == LWKT_TOKREF_MAGIC2);
+    if (lwkt_oktogiveaway_token(tok)) {
+	if (tok->t_cpu == gd)
+	    tok->t_cpu = ref->tr_reqgd;
+	cpu_mb1();
+	ref->tr_magic = LWKT_TOKREF_MAGIC1;
+    } else {
+	ref->tr_gdreqnext = gd->gd_tokreqbase;
+	gd->gd_tokreqbase = ref;
+    }
+}
+
+/*
+ * Must be called from a critical section.  Satisfy all remote token
+ * requests that are pending on our globaldata structure.  The request
+ * does not have to be satisfied with a successful change of ownership
+ * but we do have to acknowledge that we have completed processing the
+ * request by setting the magic number back to MAGIC1.
+ *
+ * NOTE!  we 'own' the ref structure, but we only 'own' the token if
+ * t_cpu == mycpu.
+ */
+void
+lwkt_drain_token_requests(void)
+{
+    globaldata_t gd = mycpu;
+    lwkt_tokref_t ref;
+
+    while ((ref = gd->gd_tokreqbase) != NULL) {
+	gd->gd_tokreqbase = ref->tr_gdreqnext;
+	KKASSERT(ref->tr_magic == LWKT_TOKREF_MAGIC2);
+	if (ref->tr_tok->t_cpu == gd)
+	    ref->tr_tok->t_cpu = ref->tr_reqgd;
+	cpu_mb1();
+	ref->tr_magic = LWKT_TOKREF_MAGIC1;
+    }
+}
+
+#endif
+
+/*
+ * Initialize the owner and release-to cpu to the current cpu
+ * and reset the generation count.
+ */
+void
+lwkt_token_init(lwkt_token_t tok)
+{
     tok->t_cpu = tok->t_reqcpu = mycpu;
-    tok->t_gen = 0;
 }
 
+void
+lwkt_token_uninit(lwkt_token_t tok)
+{
+    /* empty */
+}
Index: kern/subr_rman.c
===================================================================
RCS file: /cvs/src/sys/kern/subr_rman.c,v
retrieving revision 1.5
diff -u -r1.5 subr_rman.c
--- kern/subr_rman.c	15 Nov 2003 21:05:43 -0000	1.5
+++ kern/subr_rman.c	22 Feb 2004 03:06:30 -0000
@@ -82,11 +82,12 @@
 rman_init(struct rman *rm)
 {
 	static int once;
+	lwkt_tokref ilock;
 
 	if (once == 0) {
 		once = 1;
 		TAILQ_INIT(&rman_head);
-		lwkt_inittoken(&rman_tok);
+		lwkt_token_init(&rman_tok);
 	}
 
 	if (rm->rm_type == RMAN_UNINIT)
@@ -98,11 +99,11 @@
 	rm->rm_slock = malloc(sizeof *rm->rm_slock, M_RMAN, M_NOWAIT);
 	if (rm->rm_slock == NULL)
 		return ENOMEM;
-	lwkt_inittoken(rm->rm_slock);
+	lwkt_token_init(rm->rm_slock);
 
-	lwkt_gettoken(&rman_tok);
+	lwkt_gettoken(&ilock, &rman_tok);
 	TAILQ_INSERT_TAIL(&rman_head, rm, rm_link);
-	lwkt_reltoken(&rman_tok);
+	lwkt_reltoken(&ilock);
 	return 0;
 }
 
@@ -114,6 +115,7 @@
 rman_manage_region(struct rman *rm, u_long start, u_long end)
 {
 	struct resource *r, *s;
+	lwkt_tokref ilock;
 
 	r = malloc(sizeof *r, M_RMAN, M_NOWAIT);
 	if (r == 0)
@@ -126,7 +128,7 @@
 	r->r_dev = 0;
 	r->r_rm = rm;
 
-	lwkt_gettoken(rm->rm_slock);
+	lwkt_gettoken(&ilock, rm->rm_slock);
 	for (s = CIRCLEQ_FIRST(&rm->rm_list);	
 	     !CIRCLEQ_TERMCOND(s, rm->rm_list) && s->r_end < r->r_start;
 	     s = CIRCLEQ_NEXT(s, r_link))
@@ -138,7 +140,7 @@
 		CIRCLEQ_INSERT_BEFORE(&rm->rm_list, s, r, r_link);
 	}
 
-	lwkt_reltoken(rm->rm_slock);
+	lwkt_reltoken(&ilock);
 	return 0;
 }
 
@@ -146,11 +148,12 @@
 rman_fini(struct rman *rm)
 {
 	struct resource *r;
+	lwkt_tokref ilock;
 
-	lwkt_gettoken(rm->rm_slock);
+	lwkt_gettoken(&ilock, rm->rm_slock);
 	CIRCLEQ_FOREACH(r, &rm->rm_list, r_link) {
 		if (r->r_flags & RF_ALLOCATED) {
-			lwkt_reltoken(rm->rm_slock);
+			lwkt_reltoken(&ilock);
 			return EBUSY;
 		}
 	}
@@ -164,10 +167,11 @@
 		CIRCLEQ_REMOVE(&rm->rm_list, r, r_link);
 		free(r, M_RMAN);
 	}
-	lwkt_reltoken(rm->rm_slock);
-	lwkt_gettoken(&rman_tok);
+	lwkt_reltoken(&ilock);
+	/* XXX what's the point of this if we are going to free the struct? */
+	lwkt_gettoken(&ilock, &rman_tok);
 	TAILQ_REMOVE(&rman_head, rm, rm_link);
-	lwkt_reltoken(&rman_tok);
+	lwkt_reltoken(&ilock);
 	free(rm->rm_slock, M_RMAN);
 
 	return 0;
@@ -180,6 +184,7 @@
 	u_int	want_activate;
 	struct	resource *r, *s, *rv;
 	u_long	rstart, rend;
+	lwkt_tokref ilock;
 
 	rv = 0;
 
@@ -191,7 +196,7 @@
 	want_activate = (flags & RF_ACTIVE);
 	flags &= ~RF_ACTIVE;
 
-	lwkt_gettoken(rm->rm_slock);
+	lwkt_gettoken(&ilock, rm->rm_slock);
 
 	for (r = CIRCLEQ_FIRST(&rm->rm_list); 
 	     !CIRCLEQ_TERMCOND(r, rm->rm_list) && r->r_end < start;
@@ -396,8 +401,7 @@
 			rv = 0;
 		}
 	}
-			
-	lwkt_reltoken(rm->rm_slock);
+	lwkt_reltoken(&ilock);
 	return (rv);
 }
 
@@ -441,17 +445,21 @@
 {
 	int rv;
 	struct resource *whohas;
+	lwkt_tokref ilock;
 	struct rman *rm;
 
 	rm = r->r_rm;
-	lwkt_gettoken(rm->rm_slock);
+	lwkt_gettoken(&ilock, rm->rm_slock);
 	rv = int_rman_activate_resource(rm, r, &whohas);
-	lwkt_reltoken(rm->rm_slock);
+	lwkt_reltoken(&ilock);
 	return rv;
 }
 
+#if 0
+
+/* XXX */
 int
-rman_await_resource(struct resource *r, int slpflags, int timo)
+rman_await_resource(struct resource *r, lwkt_tokref_t ilock, int slpflags, int timo)
 {
 	int	rv, s;
 	struct	resource *whohas;
@@ -459,10 +467,10 @@
 
 	rm = r->r_rm;
 	for (;;) {
-		lwkt_gettoken(rm->rm_slock);
+		lwkt_gettoken(ilock, rm->rm_slock);
 		rv = int_rman_activate_resource(rm, r, &whohas);
 		if (rv != EBUSY)
-			return (rv);	/* returns with simple token */
+			return (rv);	/* returns with ilock held */
 
 		if (r->r_sharehead == 0)
 			panic("rman_await_resource");
@@ -474,17 +482,18 @@
 		 */
 		s = splhigh();
 		whohas->r_flags |= RF_WANTED;
-		lwkt_reltoken(rm->rm_slock);	/* YYY */
 		rv = tsleep(r->r_sharehead, slpflags, "rmwait", timo);
 		if (rv) {
+			lwkt_reltoken(ilock);
 			splx(s);
 			return rv;
 		}
-		lwkt_gettoken(rm->rm_slock);
 		splx(s);
 	}
 }
 
+#endif
+
 static int
 int_rman_deactivate_resource(struct resource *r)
 {
@@ -502,12 +511,13 @@
 int
 rman_deactivate_resource(struct resource *r)
 {
-	struct	rman *rm;
+	lwkt_tokref ilock;
+	struct rman *rm;
 
 	rm = r->r_rm;
-	lwkt_gettoken(rm->rm_slock);
+	lwkt_gettoken(&ilock, rm->rm_slock);
 	int_rman_deactivate_resource(r);
-	lwkt_reltoken(rm->rm_slock);
+	lwkt_reltoken(&ilock);
 	return 0;
 }
 
@@ -602,12 +612,13 @@
 int
 rman_release_resource(struct resource *r)
 {
-	int	rv;
 	struct	rman *rm = r->r_rm;
+	lwkt_tokref ilock;
+	int	rv;
 
-	lwkt_gettoken(rm->rm_slock);
+	lwkt_gettoken(&ilock, rm->rm_slock);
 	rv = int_rman_release_resource(rm, r);
-	lwkt_reltoken(rm->rm_slock);
+	lwkt_reltoken(&ilock);
 	return (rv);
 }
 
Index: kern/tty_tty.c
===================================================================
RCS file: /cvs/src/sys/kern/tty_tty.c,v
retrieving revision 1.6
diff -u -r1.6 tty_tty.c
--- kern/tty_tty.c	26 Aug 2003 21:09:02 -0000	1.6
+++ kern/tty_tty.c	22 Feb 2004 05:51:31 -0000
@@ -90,7 +90,7 @@
 
 	if (ttyvp == NULL)
 		return (ENXIO);
-	vn_lock(ttyvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ttyvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 #ifdef PARANOID
 	/*
 	 * Since group is tty and mode is 620 on most terminal lines
@@ -105,7 +105,7 @@
 	if (!error)
 #endif /* PARANOID */
 		error = VOP_OPEN(ttyvp, flag, NOCRED, td);
-	VOP_UNLOCK(ttyvp, 0, td);
+	VOP_UNLOCK(ttyvp, NULL, 0, td);
 	return (error);
 }
 
@@ -125,9 +125,9 @@
 	ttyvp = cttyvp(p);
 	if (ttyvp == NULL)
 		return (EIO);
-	vn_lock(ttyvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ttyvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_READ(ttyvp, uio, flag, NOCRED);
-	VOP_UNLOCK(ttyvp, 0, td);
+	VOP_UNLOCK(ttyvp, NULL, 0, td);
 	return (error);
 }
 
@@ -147,9 +147,9 @@
 	ttyvp = cttyvp(p);
 	if (ttyvp == NULL)
 		return (EIO);
-	vn_lock(ttyvp, LK_EXCLUSIVE | LK_RETRY, td);
+	vn_lock(ttyvp, NULL, LK_EXCLUSIVE | LK_RETRY, td);
 	error = VOP_WRITE(ttyvp, uio, flag, NOCRED);
-	VOP_UNLOCK(ttyvp, 0, td);
+	VOP_UNLOCK(ttyvp, NULL, 0, td);
 	return (error);
 }
 
Index: kern/uipc_syscalls.c
===================================================================
RCS file: /cvs/src/sys/kern/uipc_syscalls.c,v
retrieving revision 1.23
diff -u -r1.23 uipc_syscalls.c
--- kern/uipc_syscalls.c	20 Dec 2003 05:53:59 -0000	1.23
+++ kern/uipc_syscalls.c	22 Feb 2004 05:51:35 -0000
@@ -1484,11 +1484,11 @@
 			auio.uio_segflg = UIO_NOCOPY;
 			auio.uio_rw = UIO_READ;
 			auio.uio_td = td;
-			vn_lock(vp, LK_SHARED | LK_NOPAUSE | LK_RETRY, td);
+			vn_lock(vp, NULL, LK_SHARED | LK_NOPAUSE | LK_RETRY, td);
 			error = VOP_READ(vp, &auio, 
 				    IO_VMIO | ((MAXBSIZE / bsize) << 16),
 				    p->p_ucred);
-			VOP_UNLOCK(vp, 0, td);
+			VOP_UNLOCK(vp, NULL, 0, td);
 			vm_page_flag_clear(pg, PG_ZERO);
 			vm_page_io_finish(pg);
 			if (error) {
Index: kern/uipc_usrreq.c
===================================================================
RCS file: /cvs/src/sys/kern/uipc_usrreq.c,v
retrieving revision 1.10
diff -u -r1.10 uipc_usrreq.c
--- kern/uipc_usrreq.c	9 Oct 2003 22:27:19 -0000	1.10
+++ kern/uipc_usrreq.c	22 Feb 2004 05:35:41 -0000
@@ -627,7 +627,7 @@
 	vp->v_socket = unp->unp_socket;
 	unp->unp_vnode = vp;
 	unp->unp_addr = (struct sockaddr_un *)dup_sockaddr(nam, 1);
-	VOP_UNLOCK(vp, 0, td);
+	VOP_UNLOCK(vp, NULL, 0, td);
 	return (0);
 }
 
